## nfs-ganesha 3.2

=== src/CMakeLists.txt ===
# NFS Ganesha  Cmake

# Current version as of Fedora 16.  Not tested with earlier.

cmake_minimum_required(VERSION 2.6.3)

message( STATUS "cmake version ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" )

if( "${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" VERSION_GREATER "2.6" )
  if(COMMAND cmake_policy)
      cmake_policy(SET CMP0017 NEW)
  endif(COMMAND cmake_policy)
endif( "${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" VERSION_GREATER "2.6" )

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/modules/")

project(nfs-ganesha C CXX)
# Project versioning
set(GANESHA_MAJOR_VERSION 3)
# Minor version is blank for development.  On release, it becomes ".0".  On a
# stable maintenance branch, this becomes ".N" where N is monotonically
# increasing starting at 1. Remember to include the "." !!
set(GANESHA_MINOR_VERSION .2)

IF(CMAKE_BUILD_TYPE STREQUAL "Release" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
set(GANESHA_BUILD_RELEASE 1)
ELSE()
set(GANESHA_BUILD_RELEASE 0)
ENDIF(CMAKE_BUILD_TYPE STREQUAL "Release" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")

# needs to come after project()
IF(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT OR CMAKE_INSTALL_PREFIX STREQUAL "/usr")
	SET(CMAKE_INSTALL_PREFIX "/usr" CACHE PATH "Install prefix for common files" FORCE)
	message(STATUS "override default CMAKE_INSTALL_PREFIX = ${CMAKE_INSTALL_PREFIX}")
	SET(SYSCONFDIR "/etc" CACHE PATH "Install prefix for common files")
	SET(SYSSTATEDIR "/var" CACHE PATH "Install prefix for common files")
ELSE()
	message(STATUS "was set CMAKE_INSTALL_PREFIX = ${CMAKE_INSTALL_PREFIX}")
	SET(SYSCONFDIR "${CMAKE_INSTALL_PREFIX}/etc" CACHE PATH "Install prefix for common files")
	SET(SYSSTATEDIR "${CMAKE_INSTALL_PREFIX}/var" CACHE PATH "Install prefix for common files")
ENDIF(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT OR CMAKE_INSTALL_PREFIX STREQUAL "/usr")

# Extra version is for naming development/RC.  It is blank in master/stable branches
# so it can be available to end-users to name local variants/versions
# If used, it is always of the form "-whateveryouwant"
set(GANESHA_EXTRA_VERSION )

set(GANESHA_VERSION ${GANESHA_MAJOR_VERSION}${GANESHA_MINOR_VERSION}${GANESHA_EXTRA_VERSION})
set(GANESHA_BASE_VERSION ${GANESHA_MAJOR_VERSION}${GANESHA_MINOR_VERSION})

set(VERSION_COMMENT
  "GANESHA file server is 64 bits compliant and supports NFS v3,4.0,4.1 (pNFS) and 9P"
)

# find out which platform we are building on
if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
  set(LINUX ON)
  set(UNIX ON)
  # Now detects the Linux's distro
  set(DISTRO "UNKNOWN")
  set(LIBEXECDIR "/${CMAKE_INSTALL_PREFIX}/libexec")

  EXECUTE_PROCESS(
      COMMAND awk -F=  "/^NAME=/ { print $2 }" /etc/os-release
      OUTPUT_VARIABLE SYS_RELEASE
      ERROR_QUIET
   )
  EXECUTE_PROCESS(
      COMMAND awk -F=  "/^ID_LIKE=/ { print $2 }" /etc/os-release
      OUTPUT_VARIABLE ID_LIKE
   )
# Red Hat Enterprise Linux versions before 7.0 will be detected as UNKNOWN

  if( ${SYS_RELEASE} MATCHES "Red Hat" )
     message( STATUS "Detected a Linux Red Hat machine" )
     set(DISTRO "RED_HAT")
  elseif( ${SYS_RELEASE} MATCHES "Fedora" )
     message( STATUS "Detected a Linux Fedora machine" )
     set(DISTRO "FEDORA")
  elseif( ${SYS_RELEASE} MATCHES "SLES" )
     message( STATUS "Detected a Linux SLES machine" )
     set(DISTRO "SLES")
     set(LIBEXECDIR "/${CMAKE_INSTALL_PREFIX}/lib")
  elseif( ${SYS_RELEASE} MATCHES "openSUSE Leap" )
     message( STATUS "Detected a Linux openSUSE Leap machine" )
     set(DISTRO "SLES")
     set(LIBEXECDIR "/${CMAKE_INSTALL_PREFIX}/lib")
  elseif( ${SYS_RELEASE} MATCHES "openSUSE Tumbleweed" )
     message( STATUS "Detected a Linux openSUSE Tumbleweed machine" )
     set(DISTRO "SLES")
     set(LIBEXECDIR "/${CMAKE_INSTALL_PREFIX}/lib")
  elseif( (${SYS_RELEASE} MATCHES "Debian GNU/Linux") OR (${SYS_RELEASE} MATCHES "Ubuntu") )
     message( STATUS "Detected a Linux Debian base machine" )
     set(DISTRO "DEBIAN")
     set(LIBEXECDIR "/${CMAKE_INSTALL_PREFIX}/lib")
  else( ${SYS_RELEASE} MATCHES "Red Hat" )
     if( ${ID_LIKE} MATCHES "suse" )
         message( STATUS "Detected a SUSE Build server machine" )
         set(DISTRO "SLES")
         set(LIBEXECDIR "/usr/lib")
     else( ${ID_LIKE} MATCHES "suse" )
         message( STATUS "Detected an UNKNOWN Linux machine" )
         set(DISTRO "UNKNOWN")
     endif( ${ID_LIKE} MATCHES "suse" )
  endif( ${SYS_RELEASE} MATCHES "Red Hat" )
endif(${CMAKE_SYSTEM_NAME} MATCHES "Linux")

if(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")
  set(FREEBSD ON)
  set(UNIX ON)
# On FreeBSD libc doesn't directly provide libexecinfo, so we have to find it
  set(USE_EXECINFO ON)
  set(LIBEXECDIR "/${CMAKE_INSTALL_PREFIX}/libexec")
endif(${CMAKE_SYSTEM_NAME} MATCHES "FreeBSD")

if(${CMAKE_SYSTEM_NAME} MATCHES "Windows")
  set(WINDOWS ON)
endif(${CMAKE_SYSTEM_NAME} MATCHES "Windows")

# Identify the host we are building on
EXECUTE_PROCESS( COMMAND hostname
  OUTPUT_VARIABLE BUILD_HOST_NAME
  OUTPUT_STRIP_TRAILING_WHITESPACE
  )

find_package(Toolchain REQUIRED)
find_package(Sanitizers)

# Add maintainer mode for (mainly) strict builds
include(${CMAKE_SOURCE_DIR}/cmake/maintainer_mode.cmake)

# For libraries that provide pkg-config files
include(FindPkgConfig)

# For our option system
include(${CMAKE_SOURCE_DIR}/cmake/goption.cmake)

# If we are in a git tree, then this CMakeLists.txt is in "src/" and go .git is in "src/.."
IF( EXISTS ${CMAKE_SOURCE_DIR}/../.git/HEAD  )
  message( STATUS "Compilation from within a git repository. Using git rev-parse HEAD")
  EXECUTE_PROCESS( COMMAND git rev-parse HEAD
		   WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
		   OUTPUT_STRIP_TRAILING_WHITESPACE
		   ERROR_QUIET
                   OUTPUT_VARIABLE _GIT_HEAD_COMMIT)
  EXECUTE_PROCESS( COMMAND git describe --long
                   WORKING_DIRECTORY  ${CMAKE_SOURCE_DIR}
		   OUTPUT_STRIP_TRAILING_WHITESPACE
		   ERROR_QUIET
                   OUTPUT_VARIABLE _GIT_DESCRIBE)

ELSE( EXISTS ${CMAKE_SOURCE_DIR}/../.git/HEAD  )
  message( STATUS "Outside a git repository, use saved data" )
  EXEC_PROGRAM(${CMAKE_SOURCE_DIR}/cmake/githead_from_path.sh ARGS ${CMAKE_SOURCE_DIR}
                OUTPUT_VARIABLE  _GIT_HEAD_COMMIT)

  EXEC_PROGRAM(${CMAKE_SOURCE_DIR}/cmake/gitdesc_from_path.sh ARGS ${CMAKE_SOURCE_DIR}
                OUTPUT_VARIABLE  _GIT_DESCRIBE)

ENDIF( EXISTS ${CMAKE_SOURCE_DIR}/../.git/HEAD  )

STRING(SUBSTRING ${_GIT_HEAD_COMMIT} 0  7 _GIT_HEAD_COMMIT_ABBREV )

if (FREEBSD)
#default gcc doesn't like using -Wuninitialized without -O on FreeBSD
    set(PLATFORM "FREEBSD")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -O2 -ggdb")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fno-omit-frame-pointer")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fno-optimize-sibling-calls")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--export-dynamic")
    set(OS_INCLUDE_DIR "${PROJECT_SOURCE_DIR}/include/os/freebsd")
    find_library(LIBDL c)  # libc suffices on freebsd
endif(FREEBSD)

if (LINUX)
    set(PLATFORM "LINUX")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fno-strict-aliasing")
    set(OS_INCLUDE_DIR "${PROJECT_SOURCE_DIR}/include/os/linux")
    find_library(LIBDL dl)  # module loader
endif(LINUX)

if (MSVC)
   add_definitions(-D_CRT_SECURE_NO_WARNINGS)
endif(MSVC)

# Library path name
get_property(USE_LIB64 GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS)
if (USE_LIB64)
	set(LIB_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/lib64 CACHE PATH
		"Specify name of libdir inside install path")
else (USE_LIB64)
	set(LIB_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/lib CACHE PATH
		"Specify name of libdir inside install path")
endif (USE_LIB64)

IF(FSAL_DESTINATION)
    set( FSAL_DESTINATION ${FSAL_DESTINATION} )
ELSE()
    set( FSAL_DESTINATION "${LIB_INSTALL_DIR}/ganesha")
ENDIF()

if (CMAKE_SYSTEM_PROCESSOR MATCHES "unknown")
  # uname -p is broken on this system.  Try uname -m
  EXECUTE_PROCESS( COMMAND uname -m
		   OUTPUT_STRIP_TRAILING_WHITESPACE
		   ERROR_QUIET
		   OUTPUT_VARIABLE ARCH)
else (CMAKE_SYSTEM_PROCESSOR MATCHES "unknown")
  set(ARCH ${CMAKE_SYSTEM_PROCESSOR})
endif (CMAKE_SYSTEM_PROCESSOR MATCHES "unknown")

if (ARCH MATCHES "x86_64")
  # Nothing special to do for x86_64
elseif (ARCH MATCHES "i386")
  # Nothing special to do for i386
elseif (ARCH MATCHES "mips")
  set(SYSTEM_LIBRARIES "-latomic" ${SYSTEM_LIBRARIES})
else()
  message(WARNING "Unhandled architecture ${ARCH}")
endif ()

# FSAL selection
# FSALs which are enabled by default but could be disabled
# during the build
goption(USE_FSAL_PROXY "build PROXY FSAL shared library" ON)
goption(USE_FSAL_VFS "build VFS FSAL shared library" ON)
goption(USE_FSAL_LUSTRE "build LUSTRE FSAL shared library" ON)
goption(USE_FSAL_LIZARDFS "build LIZARDFS FSAL shared library" ON)
goption(USE_FSAL_CEPH "build CEPH FSAL shared library" ON)
goption(USE_FSAL_GPFS "build GPFS FSAL" ON)
goption(USE_FSAL_XFS "build XFS support in VFS FSAL" ON)
goption(USE_FSAL_PANFS "build PanFS support in VFS FSAL" OFF)
goption(USE_FSAL_GLUSTER "build GLUSTER FSAL shared library" ON)
goption(USE_FSAL_NULL "build NULL FSAL shared library" ON)
goption(USE_FSAL_RGW "build RGW FSAL shared library" ON)
goption(USE_FSAL_MEM "build Memory FSAL shared library" ON)

# nTIRPC
option(USE_SYSTEM_NTIRPC "Use the system nTIRPC, rather than the submodule" OFF)
option (USE_GSS "enable RPCSEC_GSS support" ON)
option(TIRPC_EPOLL "platform supports EPOLL or emulation" ON)

# Build configure options
goption(USE_DBUS "enable DBUS protocol support" ON)

# Various DBUS enabled features
option(USE_CB_SIMULATOR "enable callback simulator thread" OFF)

goption(USE_NFSIDMAP "Use of libnfsidmap for name resolution" ON)
option(ENABLE_ERROR_INJECTION "enable error injection" OFF)
option(ENABLE_VFS_DEBUG_ACL "Enable debug ACL store for VFS" OFF)
option(ENABLE_RFC_ACL "Use all RFC ACL checks" OFF)
option(USE_TOOL_MULTILOCK "build multilock tool" OFF)

# Electric Fence (-lefence) link flag
goption(USE_EFENCE "link with efence memory debug library" OFF)

# These are -D_FOO options, why ???  should be flags??
option(_NO_TCP_REGISTER "disable registration of tcp services on portmapper" OFF)
option(RPCBIND "enable registration with rpcbind" ON)
option(DEBUG_SAL "enable debugging of SAL by keeping list of all locks, stateids, and state owners" OFF)
option(_VALGRIND_MEMCHECK "Initialize buffers passed to GPFS ioctl that valgrind doesn't understand" OFF)
option(ENABLE_LOCKTRACE "Enable lock trace" OFF)
goption(PROXY_HANDLE_MAPPING "enable NFSv3 handle mapping for PROXY FSAL" OFF)
option(DEBUG_MDCACHE "Add various asserts to mdcache" OFF)

# Debug symbols (-g) build flag
option(DEBUG_SYMS "include debug symbols to binaries (-g option)" OFF)

# Add coverage information to build tree
option(COVERAGE "add flag to generate coverage data at runtime" OFF)

option(ENFORCE_GCC "enforce gcc as a the C compiler used for the project" OFF)

# Define CPACK component (to deal with sub packages)
set(CPACK_COMPONENTS_ALL daemon fsal headers tools)
set(CPACK_COMPONENT_DAEMON_DISPLAY_NAME "NFS-Ganesha daemon")
if (USE_SYSTEM_NTIRPC)
  # Don't include libntirpc in the tarball
  set(CPACK_SOURCE_IGNORE_FILES "libntirpc")
else(USE_SYSTEM_NTIRPC)
  # Don't include libntirpc's spec file; this can confuse rpmbuild
  set(CPACK_SOURCE_IGNORE_FILES "libntirpc.spec$")
endif(USE_SYSTEM_NTIRPC)

# Include custom config and cpack module
include(${CMAKE_SOURCE_DIR}/cmake/cpack_config.cmake)
include(CPack)

# MSPAC support -lwbclient link flag
goption(_MSPAC_SUPPORT "enable mspac Winbind support" ON)

# CUnit
goption(USE_CUNIT "Use Cunit test framework" OFF)

# Blkin (Zipkin) Tracing
option(USE_BLKIN "Use Blkin/Zipkin trace framework" OFF)
option(BLKIN_PREFIX "Blkin installation prefix" "/opt/blkin")
if(USE_BLKIN)
  find_package(LTTng)
  if(LTTNG_FOUND)
  else(LTTNG_FOUND)
    message(WARNING "LTTng libraries not found. Disabling USE_BLKIN")
    set(USE_BLKIN OFF)

=== debian/changelog ===
nfs-ganesha (3.2-4) bullseye; urgency=medium

  * nfs-ganesha 3.2 NFSv4-compound-op-fails SEGV

 -- Gluster Packager <glusterpackager@download.gluster.org>  Fri, 28 Feb 2020 15:30:00 -0400

nfs-ganesha (3.2-3) bullseye; urgency=medium

  * nfs-ganesha 3.2 libganesha_*.so* to /usr/lib/*-linux-gnu/

 -- Gluster Packager <glusterpackager@download.gluster.org>  Fri, 28 Feb 2020 15:30:00 -0400

nfs-ganesha (3.2-2) bullseye; urgency=medium

  * nfs-ganesha 3.2 libtirpc-common -> libtirpc3

 -- Gluster Packager <glusterpackager@download.gluster.org>  Tue, 11 Feb 2020 15:30:00 -0400

nfs-ganesha (3.2-1) bullseye; urgency=medium

  * nfs-ganesha 3.2 GA

 -- Gluster Packager <glusterpackager@download.gluster.org>  Mon, 13 Jan 2020 15:30:00 -0400

nfs-ganesha (3.0-1) bullseye; urgency=medium

  * nfs-ganesha 3.0 GA

 -- Gluster Packager <glusterpackager@download.gluster.org>  Thu, 14 Nov 2019 15:30:00 -0400

nfs-ganesha (2.8.2-2) bullseye; urgency=medium

  * nfs-ganesha 2.8.2 w/ pyqt5 again

 -- Gluster Packager <glusterpackager@download.gluster.org>  Mon, 23 Sep 2019 15:30:00 -0400

nfs-ganesha (2.8.2-1) buster; urgency=medium

  * nfs-ganesha 2.8.2 GA and w/ pyqt5

 -- Gluster Packager <glusterpackager@download.gluster.org>  Mon, 23 Sep 2019 15:30:00 -0400

=== debian/control ===
Source: nfs-ganesha
Section: net
Priority: optional
Maintainer: Gluster Packager <glusterpackager@download.gluster.org>
Standards-Version: 3.9.7
Homepage: https://github.com/nfs-ganesha/nfs-ganesha
Build-Depends: debhelper (>= 9),
               bison,
               flex,
               cmake,
               libdbus-1-dev,
               libnfsidmap-dev,
               libwbclient-dev,
               libntirpc-dev (>= 3.2),
               libkrb5-dev,
               libblkid-dev,
               libattr1-dev,
               libacl1-dev,
               lttng-tools,
               liblttng-ust-dev,
               liblttng-ctl-dev,
               liburcu-dev,
               xfslibs-dev,
               uuid-dev,
               libcap-dev,
               libglusterfs-dev (>= 6.0),
               librados-dev,
               libcephfs-dev,
               python3-dev,
               dh-python,
               dh-systemd,
               python3-pyqt5,
               python3-sphinx,
               pyqt5-dev-tools,
               pkgconf
Vcs-Git: https://github.com/nfs-ganesha/nfs-ganesha.git

Package: nfs-ganesha
Architecture: any
Depends: dbus, nfs-common, rpcbind,
         ${shlibs:Depends},
         ${perl:Depends},
         ${misc:Depends},
         libwbclient0,
         liburcu6,
         libntirpc3 (>= 3.2),
         libtirpc3,
         daemon
Description: nfs-ganesha is a NFS server in User Space
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.

Package: nfs-ganesha-mount-9p
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
         nfs-ganesha (=${binary:Version}),
Description: nfs-ganesha mount.9P
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 This package contains mount.9P

Package: nfs-ganesha-gluster
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
         nfs-ganesha (=${binary:Version}),
         libglusterfs0 (>= 6.0)
Description: nfs-ganesha fsal gluster libraries
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 This package contains a library for FSAL_GLUSTER and an example .conf file

Package: nfs-ganesha-ceph
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
         nfs-ganesha (=${binary:Version}),
         libcephfs2
Description: nfs-ganesha fsal ceph libraries
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 This package contains a library for a FSAL_CEPH and an example ceph.conf file

Package: nfs-ganesha-vfs
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
         nfs-ganesha (=${binary:Version})
Description: nfs-ganesha fsal vfs libraries
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 This package contains a library for a FSAL_VFS and an example vfs.conf file

Package: nfs-ganesha-rados-grace
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
         nfs-ganesha (=${binary:Version}),
         librados2
Description: nfs-ganesha ganesha-rados-grace program
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 This package contains the ganesha-rados-grace program

Package: nfs-ganesha-nullfs
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
         nfs-ganesha (=${binary:Version})
Description: nfs-ganesha fsal nullfs libraries
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 This package contains a library for a FSAL_NULLFS

Package: nfs-ganesha-mem
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
         nfs-ganesha (=${binary:Version})
Description: nfs-ganesha fsal mem libraries
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 This package contains a library for a FSAL_MEM

Package: nfs-ganesha-proxy
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
         nfs-ganesha (=${binary:Version})
Description: nfs-ganesha fsal proxy libraries
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 This package contains a library for a FSAL_PROXY

Package: nfs-ganesha-gpfs
Multi-Arch: same
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
         nfs-ganesha (=${binary:Version})
Description: nfs-ganesha fsal gpfs libraries
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 This package contains a library for a FSAL_GPFS and conf files.


Package: python3-nfs-ganesha
Pre-Depends: ${misc:Pre-Depends}
Replaces: python-nfs-ganesha
Architecture: all
Section: python
Provides: ${python:Provides}
Depends: python3-dbus,
         python3-pyqt5,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: Python bindings for nfs-ganesha
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 .
 This package contains Python bindings for nfs-ganesha admin

Package: nfs-ganesha-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Documentation for nfs-ganesha
 NFS-GANESHA is a NFS Server running in user space with a large cache.
 It comes with various backend modules to support different file systems
 and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
 HPSS, LUSTRE, XFS and ZFS.
 .
 This package contains documentation and examples for nfs-ganesha

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#
# Expected debian/rules file that is used by the dpkg build procedure
#
#   $ git clone <nfs-ganesha>
#   $ cd nfs-ganesha/src
#   $ dpkg-buildpackage -uc -us
#
export PREFIX=/usr
export DESTDIR=$(CURDIR)/debian/tmp

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	 dh $@ --with python3,systemd

override_dh_auto_configure:
	 cd src && ln -s ../debian .
	 cd src && dh_auto_configure -- \
		-DBUILD_CONFIG=debian \
		-DLIB_INSTALL_DIR:STRING=lib/${DEB_HOST_MULTIARCH} \
		-DFSAL_DESTINATION=/usr/lib/${DEB_HOST_MULTIARCH}/ganesha \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DUSE_FSAL_NULL=YES \
		-DUSE_FSAL_MEM=YES \
		-DUSE_FSAL_XFS=NO \
		-DUSE_FSAL_LUSTRE=NO \
		-DUSE_FSAL_CEPH=YES \
		-DUSE_FSAL_RGW=NO \
		-DUSE_FSAL_GPFS=YES \
		-DUSE_FSAL_PANFS=NO \
		-DUSE_FSAL_GLUSTER=YES \
		-DUSE_SYSTEM_NTIRPC=YES \
		-DUSE_9P_RDMA=NO \
		-DUSE_LTTNG=NO \
		-DUSE_ADMIN_TOOLS=YES \
		-DUSE_RADOS_RECOV=YES \
		-DRADOS_URLS=YES \
		-DUSE_GUI_ADMIN_TOOLS=YES \
		-DUSE_FSAL_VFS=ON \
		-DUSE_FSAL_PROXY=ON \
		-DUSE_DBUS=ON \
		-DUSE_9P=ON \
		-DDISTNAME_HAS_GIT_DATA=OFF \
		-DUSE_MAN_PAGE=YES \
		-D_MSPAC_SUPPORT=YES \
		-DSANITIZE_ADDRESS=NO


override_dh_auto_build:
	cd src && dh_auto_build

override_dh_auto_test:

override_dh_install:
	mkdir -p debian/tmp/etc/ganesha/
	mkdir -p debian/tmp/lib/systemd/system
	mkdir -p debian/tmp/etc/default
	mkdir -p debian/tmp/etc/logrotate.d/
	mkdir -p debian/tmp/etc/dbus-1/system.d/
	mkdir -p debian/tmp/usr/lib/ganesha
	mkdir -p debian/tmp/usr/lib/${DEB_HOST__MULTIARCH}/ganesha
	mkdir -p debian/tmp/usr/sbin/
	cp src/config_samples/vfs.conf debian/tmp/etc/ganesha/ganesha.conf
	cp src/config_samples/vfs.conf debian/tmp/etc/ganesha/vfs.conf
	cp src/config_samples/rgw.conf debian/tmp/etc/ganesha/rgw.conf
	cp src/config_samples/mem.conf debian/tmp/etc/ganesha/mem.conf
	cp src/config_samples/gluster.conf debian/tmp/etc/ganesha/gluster.conf
	cp src/config_samples/ceph.conf debian/tmp/etc/ganesha/ceph.conf
	cp src/config_samples/gpfs.conf debian/tmp/etc/ganesha/gpfs.conf
	cp src/config_samples/gpfs.ganesha.exports.conf debian/tmp/etc/ganesha/gpfs.ganesha.exports.conf
	cp src/config_samples/gpfs.ganesha.log.conf debian/tmp/etc/ganesha/gpfs.ganesha.log.conf
	cp src/config_samples/gpfs.ganesha.main.conf debian/tmp/etc/ganesha/gpfs.ganesha.main.conf
	cp src/config_samples/gpfs.ganesha.nfsd.conf debian/tmp/etc/ganesha/gpfs.ganesha.nfsd.conf
	cp src/config_samples/logrotate_ganesha debian/tmp/etc/logrotate.d/nfs-ganesha
	cp src/config_samples/logrotate_fsal_gluster debian/tmp/etc/logrotate.d/nfs-ganesha-gfapi
	cp src/scripts/systemd/nfs-ganesha.service.debian8 debian/tmp/lib/systemd/system/nfs-ganesha.service
	cp src/scripts/systemd/nfs-ganesha-lock.service.debian8 src/scripts/systemd/nfs-ganesha-lock.service
	cp src/scripts/systemd/nfs-ganesha-config.service debian/tmp/lib/systemd/system/
	cp src/scripts/systemd/nfs-ganesha-lock.service.debian8 debian/tmp/lib/systemd/system/nfs-ganesha-lock.service
	cp src/scripts/systemd/sysconfig/nfs-ganesha debian/tmp/etc/default/
	cp src/scripts/ganeshactl/org.ganesha.nfsd.conf debian/tmp/etc/dbus-1/system.d/nfs-ganesha-dbus.conf
	install -m 0755 src/scripts/nfs-ganesha-config.sh debian/tmp/usr/lib/ganesha/
	install -m 0755 src/tools/mount.9P debian/tmp/usr/sbin/
	make -C src/obj-*-linux-gnu* install && dh_install --sourcedir=./src

## nfs-ganesha 3.4

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -20,7 +20,7 @@
 # Minor version is blank for development.  On release, it becomes ".0".  On a
 # stable maintenance branch, this becomes ".N" where N is monotonically
 # increasing starting at 1. Remember to include the "." !!
-set(GANESHA_MINOR_VERSION .2)
+set(GANESHA_MINOR_VERSION .4)
 
 IF(CMAKE_BUILD_TYPE STREQUAL "Release" OR CMAKE_BUILD_TYPE STREQUAL "RelWithDebInfo")
 set(GANESHA_BUILD_RELEASE 1)
@@ -40,7 +40,7 @@
 	SET(SYSSTATEDIR "${CMAKE_INSTALL_PREFIX}/var" CACHE PATH "Install prefix for common files")
 ENDIF(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT OR CMAKE_INSTALL_PREFIX STREQUAL "/usr")
 
-# Extra version is for naming development/RC.  It is blank in master/stable branches
+# Extra version is for naming development/RC.  It is blank in stable branches
 # so it can be available to end-users to name local variants/versions
 # If used, it is always of the form "-whateveryouwant"
 set(GANESHA_EXTRA_VERSION )

=== src/MainNFSD/CMakeLists.txt ===
add_definitions(
  -D__USE_GNU
  -D_GNU_SOURCE
)

if(USE_DBUS)
  include_directories(
    ${DBUS_INCLUDE_DIRS}
    )
endif(USE_DBUS)

if(RADOS_URLS)
  include_directories(
	  ${RADOS_INCLUDE_DIR}
    )
endif(RADOS_URLS)
########### next target ###############

SET(MainServices_STAT_SRCS
   nfs_admin_thread.c
   nfs_rpc_callback.c
   nfs_worker_thread.c
   nfs_rpc_dispatcher_thread.c
   nfs_rpc_tcp_socket_manager_thread.c
   nfs_init.c
   nfs_lib.c
   nfs_reaper_thread.c
   ../support/client_mgr.c
)

if(USE_9P)
  SET(MainServices_STAT_SRCS
    ${MainServices_STAT_SRCS}
    9p_dispatcher.c)
endif(USE_9P)

if(USE_9P AND USE_9P_RDMA)
  SET(MainServices_STAT_SRCS
    ${MainServices_STAT_SRCS}
    9p_rdma_dispatcher.c
    9p_rdma_callbacks.c)
endif(USE_9P AND USE_9P_RDMA)

if(USE_NFS_RDMA)
  add_definitions(-D_USE_NFS_RDMA)
endif(USE_NFS_RDMA)

if(USE_CB_SIMULATOR)
  SET(MainServices_STAT_SRCS
    ${MainServices_STAT_SRCS}
    nfs_rpc_callback_simulator.c)
endif(USE_CB_SIMULATOR)

if(USE_UPCALL_SIMULATOR)
  SET(MainServices_STAT_SRCS
    ${MainServices_STAT_SRCS}
    fsal_upcall_simulator_thread.c
    )
endif(USE_UPCALL_SIMULATOR)

if(USE_CB_SIMULATOR)
  SET(MainServices_STAT_SRCS
    ${MainServices_STAT_SRCS}
    nfs_rpc_callback_simulator.c
    )
endif(USE_CB_SIMULATOR)

add_library(MainServices OBJECT ${MainServices_STAT_SRCS})
add_sanitizers(MainServices)
set_target_properties(MainServices PROPERTIES COMPILE_FLAGS "-fPIC")

# FSAL core sources
# fsal_manager and fsal_destroyer are the only objects referenced by the
# core server all the rest are for the common support of fsal plugins.

set(fsal_CORE_SRCS
   ../FSAL/fsal_convert.c
   ../FSAL/commonlib.c
   ../FSAL/fsal_manager.c
   ../FSAL/access_check.c
   ../FSAL/fsal_config.c
   ../FSAL/default_methods.c
   ../FSAL/common_pnfs.c
   ../FSAL/fsal_destroyer.c
   ../FSAL/fsal_helper.c
   ../FSAL_UP/fsal_up_top.c
   ../FSAL_UP/fsal_up_async.c
)

if (USE_ACL_MAPPING)
  set(fsal_CORE_SRCS
      ${fsal_CORE_SRCS}
      ../FSAL/posix_acls.c
  )
endif(USE_ACL_MAPPING)

set(ganesha_nfsd_OBJS
    $<TARGET_OBJECTS:MainServices>
    $<TARGET_OBJECTS:avltree>
    $<TARGET_OBJECTS:cidr>
    $<TARGET_OBJECTS:config_parsing>
    $<TARGET_OBJECTS:hashtable>
    $<TARGET_OBJECTS:idmap>
    $<TARGET_OBJECTS:log>
    $<TARGET_OBJECTS:gos>
    $<TARGET_OBJECTS:rpcal>
    $<TARGET_OBJECTS:sal>
    $<TARGET_OBJECTS:support>
    $<TARGET_OBJECTS:string_utils>
    $<TARGET_OBJECTS:hash>
    $<TARGET_OBJECTS:uid2grp>
    $<TARGET_OBJECTS:netgroup_cache>
    $<TARGET_OBJECTS:nfsproto>
    $<TARGET_OBJECTS:nfs4callbacks>
    $<TARGET_OBJECTS:rquota>
    $<TARGET_OBJECTS:nfs_mnt_xdr>
    $<TARGET_OBJECTS:fsalpseudo>
    $<TARGET_OBJECTS:fsalmdcache>
)

if(USE_DBUS)
  set(ganesha_nfsd_OBJS
    ${ganesha_nfsd_OBJS}
    $<TARGET_OBJECTS:gshdbus>
  )
endif(USE_DBUS)

if(USE_NLM)
  set(ganesha_nfsd_OBJS
    ${ganesha_nfsd_OBJS}
    $<TARGET_OBJECTS:nlm>
  )
endif(USE_NLM)

if(USE_9P)
  set(ganesha_nfsd_OBJS
    ${ganesha_nfsd_OBJS}
    $<TARGET_OBJECTS:9p>
  )
endif(USE_9P)

add_library(ganesha_nfsd SHARED
  ${ganesha_nfsd_OBJS} ${fsal_CORE_SRCS}
)

add_sanitizers(ganesha_nfsd)

target_link_libraries(ganesha_nfsd
  ${LIBTIRPC_LIBRARIES}
  ${SYSTEM_LIBRARIES}
  ${LTTNG_LIBRARIES}
)

if(USE_9P_RDMA)
  target_link_libraries(ganesha_nfsd ${MOOSHIKA_LIBRARIES})
endif(USE_9P_RDMA)

if(SANITIZE_ADDRESS)
	set_target_properties(ganesha_nfsd PROPERTIES LINK_FLAGS "-Wl,--version-script=${CMAKE_SOURCE_DIR}/MainNFSD/libganesha_nfsd.ver")
else(SANITIZE_ADDRESS)
	set_target_properties(ganesha_nfsd PROPERTIES LINK_FLAGS "-Wl,--version-script=${CMAKE_SOURCE_DIR}/MainNFSD/libganesha_nfsd.ver -Wl,--no-undefined")
endif(SANITIZE_ADDRESS)

set_target_properties(ganesha_nfsd PROPERTIES
  VERSION "${GANESHA_MAJOR_VERSION}${GANESHA_MINOR_VERSION}"
  SOVERSION "${GANESHA_MAJOR_VERSION}${GANESHA_MINOR_VERSION}"
)
install(TARGETS ganesha_nfsd LIBRARY DESTINATION ${LIB_INSTALL_DIR})

#install(TARGETS ganesha.nfsd COMPONENT daemon DESTINATION bin)

########### install files ###############

# We are still missing the install of docs and stuff

=== src/Protocols/CMakeLists.txt ===
add_subdirectory(NFS)
add_subdirectory(XDR)
if(USE_NLM)
	add_subdirectory(NLM)
endif(USE_NLM)
add_subdirectory(RQUOTA)

if(USE_9P)
  add_subdirectory(9P)
endif(USE_9P)

########### install files ###############

=== src/avl/CMakeLists.txt ===

########### next target ###############

SET(avltree_STAT_SRCS
   avl.c
   bst.c
   rb.c
   splay.c
)

add_library(avltree OBJECT ${avltree_STAT_SRCS})
add_sanitizers(avltree)
set_target_properties(avltree PROPERTIES COMPILE_FLAGS "-fPIC")

########### install files ###############

=== src/cidr/CMakeLists.txt ===

########### next target ###############

SET(cidr_STAT_SRCS
   cidr_addr.c
   cidr_compare.c
   cidr_from_str.c
   cidr_get.c
   cidr_inaddr.c
   cidr_mem.c
   cidr_misc.c
   cidr_net.c
   cidr_num.c
   cidr_to_str.c
   cidr_pow2_p.h
)

add_library(cidr OBJECT ${cidr_STAT_SRCS})
add_sanitizers(cidr)
set_target_properties(cidr PROPERTIES COMPILE_FLAGS "-fPIC")

########### install files ###############

=== src/os/CMakeLists.txt ===
# All we need to do here is control the
# build of chosen platform

if(FREEBSD)
  SET(gos_STAT_SRCS
      freebsd/atsyscalls.c
      freebsd/mntent_compat.c
      freebsd/subr.c
      freebsd/xattr.c
  )
endif(FREEBSD)

if(LINUX)
  SET(gos_STAT_SRCS
      linux/subr.c
  )
endif(LINUX)

add_library(gos OBJECT ${gos_STAT_SRCS})
add_sanitizers(gos)
set_target_properties(gos PROPERTIES COMPILE_FLAGS "-fPIC")

########### install files ###############

=== src/tracing/CMakeLists.txt ===
include_directories(
  ${LTTNG_INCLUDE_DIR}
)

set(ganesha_trace_LIB_SRCS
  fsal_mem.c
  logger.c
  mdcache.c
  nfs4.c
  nfs_rpc.c
  state.c
  fsal_gluster.c
)

add_library(ganesha_trace MODULE ${ganesha_trace_LIB_SRCS})
add_sanitizers(ganesha_trace)

target_link_libraries(ganesha_trace
  ${LTTNG_LIBRARIES}
)

install(TARGETS ganesha_trace COMPONENT tracing DESTINATION ${FSAL_DESTINATION} )

=== src/FSAL/FSAL_GLUSTER/CMakeLists.txt ===
add_definitions(
  -D__USE_GNU
  -D_GNU_SOURCE
  ${GFAPI_CFLAGS}
)

set( LIB_PREFIX 64)

#add_subdirectory(pnfs_panfs)

#if(USE_FSAL_XFS)
#    add_subdirectory(xfs)
#endif(USE_FSAL_XFS)

########### next target ###############

SET(fsalgluster_LIB_SRCS
   main.c
   export.c
   handle.c
   fsal_up.c
   gluster_internal.h
   gluster_internal.c
   mds.c
   ds.c
)

add_library(fsalgluster MODULE ${fsalgluster_LIB_SRCS})
add_sanitizers(fsalgluster)

target_link_libraries(fsalgluster
  ganesha_nfsd
  ${SYSTEM_LIBRARIES}
  ${GFAPI_LIBRARIES}
  ${LTTNG_LIBRARIES}
  "-Wl,--no-undefined"
)

set_target_properties(fsalgluster PROPERTIES VERSION 4.2.0 SOVERSION 4)
install(TARGETS fsalgluster COMPONENT fsal DESTINATION ${FSAL_DESTINATION} )

########### install files ###############

=== src/FSAL/FSAL_PSEUDO/CMakeLists.txt ===
add_definitions(
  -D__USE_GNU
  -D_GNU_SOURCE
)

set( LIB_PREFIX 64)

########### next target ###############

SET(fsalpseudo_LIB_SRCS
   handle.c
   pseudofs_methods.h
   main.c
   export.c
)

add_library(fsalpseudo OBJECT ${fsalpseudo_LIB_SRCS})
add_sanitizers(fsalpseudo)
set_target_properties(fsalpseudo PROPERTIES COMPILE_FLAGS "-fPIC")

########### install files ###############

=== src/Protocols/9P/CMakeLists.txt ===

########### next target ###############

SET(9p_STAT_SRCS
   9p_interpreter.c
   9p_proto_tools.c
   9p_read_conf.c
   9p_attach.c
   9p_auth.c
   9p_clunk.c
   9p_flush.c
   9p_flush_hook.c
   9p_getattr.c
   9p_getlock.c
   9p_lcreate.c
   9p_lopen.c
   9p_link.c
   9p_lock.c
   9p_mkdir.c
   9p_mknod.c
   9p_read.c
   9p_readdir.c
   9p_readlink.c
   9p_remove.c
   9p_rename.c
   9p_renameat.c
   9p_fsync.c
   9p_unlinkat.c
   9p_setattr.c
   9p_statfs.c
   9p_symlink.c
   9p_version.c
   9p_walk.c
   9p_xattrcreate.c
   9p_xattrwalk.c
   9p_write.c
   9p_rerror.c
)

add_library(9p OBJECT ${9p_STAT_SRCS})
add_sanitizers(9p)
set_target_properties(9p PROPERTIES COMPILE_FLAGS "-fPIC")

########### install files ###############

=== src/Protocols/NLM/CMakeLists.txt ===
########### next target ###############

SET(nlm_STAT_SRCS
   nlm_Cancel.c
   nlm_Free_All.c
   nlm_Granted_Res.c
   nlm_Lock.c
   nlm_Null.c
   nlm_Share.c
   nlm_Sm_Notify.c
   nlm_Test.c
   nlm_Unlock.c
   nlm_Unshare.c
   nlm_async.c
   nlm_util.c
   nsm.c
)

add_library(nlm OBJECT ${nlm_STAT_SRCS})
add_sanitizers(nlm)
set_target_properties(nlm PROPERTIES COMPILE_FLAGS "-fPIC")

########### install files ###############

=== src/Protocols/XDR/CMakeLists.txt ===

########### next target ###############

SET(nfs_mnt_xdr_STAT_SRCS
   xdr_mount.c
   xdr_nfs23.c
   xdr_nfsv41.c
   xdr_rquota.c
   xdr_nlm4.c
   xdr_nsm.c
)

add_library(nfs_mnt_xdr OBJECT ${nfs_mnt_xdr_STAT_SRCS})
add_sanitizers(nfs_mnt_xdr)
set_target_properties(nfs_mnt_xdr PROPERTIES COMPILE_FLAGS "-fPIC")

########### install files ###############

=== debian/changelog ===
nfs-ganesha (3.4-1) unstable; urgency=medium

  * New upstream version 3.4

 -- Christoph Martin <martin@uni-mainz.de>  Wed, 20 Jan 2021 15:12:04 +0100

nfs-ganesha (3.3-3) unstable; urgency=medium

  * remove dependency from obsolete dh-systemd (closes: 979419)

 -- Christoph Martin <martin@uni-mainz.de>  Thu, 07 Jan 2021 00:31:17 +0100

nfs-ganesha (3.3-2) unstable; urgency=medium

  * source only upload to allow migration to testing (no code changes)

 -- Christoph Martin <martin@uni-mainz.de>  Wed, 06 Jan 2021 13:53:38 +0100

nfs-ganesha (3.3-1) unstable; urgency=medium

  [ Christian Ehrhardt ]
  * d/control: Drop runtime dependency on daemon as its not used.

  [ Christoph Martin ]
  * New upstream version 3.3
  * include upstream nfs-ganesha-debian/nfs-ganesha-bullseye changes
    (closes: #952406)
  * adds nfs-ganesha-rgw (closes: #862979, #959482)
  * fix referral xattr refresh

 -- Christoph Martin <martin@uni-mainz.de>  Fri, 09 Oct 2020 14:05:32 +0200

nfs-ganesha (3.2-3) unstable; urgency=medium

  * fix FTBFS gcc-10 (closes: #966869) (thanks to Lucas Kanashiro
    <kanashiro@debian.org>)
  * install correct initial ganesha.conf from example.

 -- Christoph Martin <martin@uni-mainz.de>  Wed, 12 Aug 2020 15:00:18 +0200

nfs-ganesha (3.2-2) unstable; urgency=medium

  * source only upload to enable migration to testing

 -- Christoph Martin <martin@uni-mainz.de>  Mon, 16 Mar 2020 12:33:18 +0100

nfs-ganesha (3.2-1) unstable; urgency=medium

  * New upstream version 3.2
  * add python3-nfs-ganesha
  * add nfs-ganesha-rados-grace
  * remove nfs-ganesha-xfs
  * remove unneeded patch files
  * fix install path for new private libraries
  * cleanup copyright file
  * new version fixes build problems (closes: #952050)

 -- Christoph Martin <martin@uni-mainz.de>  Mon, 02 Mar 2020 10:10:27 +0100

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,18 @@
 Source: nfs-ganesha
 Section: net
 Priority: optional
-Maintainer: Gluster Packager <glusterpackager@download.gluster.org>
-Standards-Version: 3.9.7
+Maintainer: Philippe Deniel <philippe.deniel@cea.fr>
+Uploaders: Christoph Martin <martin@uni-mainz.de>
+Standards-Version: 4.1.1
 Homepage: https://github.com/nfs-ganesha/nfs-ganesha
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 10),
                bison,
                flex,
                cmake,
                libdbus-1-dev,
                libnfsidmap-dev,
                libwbclient-dev,
-               libntirpc-dev (>= 3.2),
+               libntirpc-dev (>= 3.4),
                libkrb5-dev,
                libblkid-dev,
                libattr1-dev,
@@ -26,43 +27,41 @@
                libglusterfs-dev (>= 6.0),
                librados-dev,
                libcephfs-dev,
+               librgw-dev,
                python3-dev,
                dh-python,
-               dh-systemd,
                python3-pyqt5,
                python3-sphinx,
                pyqt5-dev-tools,
                pkgconf
-Vcs-Git: https://github.com/nfs-ganesha/nfs-ganesha.git
+Vcs-Git: https://salsa.debian.org/debian/nfs-ganesha.git
+Vcs-Browser: https://salsa.debian.org/debian/nfs-ganesha
 
 Package: nfs-ganesha
+Multi-Arch: foreign
 Architecture: any
 Depends: dbus, nfs-common, rpcbind,
          ${shlibs:Depends},
          ${perl:Depends},
          ${misc:Depends},
-         libwbclient0,
-         liburcu6,
-         libntirpc3 (>= 3.2),
-         libtirpc3,
-         daemon
-Description: nfs-ganesha is a NFS server in User Space
- NFS-GANESHA is a NFS Server running in user space with a large cache.
- It comes with various backend modules to support different file systems
- and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
- HPSS, LUSTRE, XFS and ZFS.
+Description: NFS server in User Space
+ NFS-GANESHA is a NFS Server running in user space with a large cache.
+ It comes with various backend modules to support different file systems
+ and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
+ HPSS, LUSTRE, XFS and ZFS.
+ .
+ This package contains the binaries
 
 Package: nfs-ganesha-mount-9p
-Multi-Arch: same
-Architecture: any
-Section: libs
-Depends: ${misc:Depends}, ${shlibs:Depends},
-         nfs-ganesha (=${binary:Version}),
+Architecture: all
+Depends: ${misc:Depends}, ${shlibs:Depends},
+         nfs-ganesha (>=${source:Version})
 Description: nfs-ganesha mount.9P
  NFS-GANESHA is a NFS Server running in user space with a large cache.
  It comes with various backend modules to support different file systems
  and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
  HPSS, LUSTRE, XFS and ZFS.
+ .
  This package contains mount.9P
 
 Package: nfs-ganesha-gluster
@@ -84,8 +83,7 @@
 Architecture: any
 Section: libs
 Depends: ${misc:Depends}, ${shlibs:Depends},
-         nfs-ganesha (=${binary:Version}),
-         libcephfs2
+         nfs-ganesha (=${binary:Version})
 Description: nfs-ganesha fsal ceph libraries
  NFS-GANESHA is a NFS Server running in user space with a large cache.
  It comes with various backend modules to support different file systems
@@ -93,6 +91,20 @@
  HPSS, LUSTRE, XFS and ZFS.
  This package contains a library for a FSAL_CEPH and an example ceph.conf file
 
+Package: nfs-ganesha-rgw
+Multi-Arch: same
+Architecture: any
+Section: libs
+Depends: ${misc:Depends}, ${shlibs:Depends},
+        nfs-ganesha (=${binary:Version})
+Description: nfs-ganesha fsal rgw libraries
+ NFS-GANESHA is a NFS Server running in user space with a large cache.
+ It comes with various backend modules to support different file systems
+ and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
+ HPSS, LUSTRE, XFS and ZFS.
+ .
+ This package contains a library for a FSAL_RGW and an example rgw.conf file
+
 Package: nfs-ganesha-vfs
 Multi-Arch: same
 Architecture: any
@@ -106,13 +118,24 @@
  HPSS, LUSTRE, XFS and ZFS.
  This package contains a library for a FSAL_VFS and an example vfs.conf file
 
+#Package: nfs-ganesha-xfs
+#Multi-Arch: same
+#Architecture: any
+#Section: libs
+#Depends: ${misc:Depends}, ${shlibs:Depends},
+#         nfs-ganesha (=${binary:Version})
+#Description: nfs-ganesha fsal xfs libraries
+# NFS-GANESHA is a NFS Server running in user space with a large cache.
+# It comes with various backend modules to support different file systems
+# and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
+# HPSS, LUSTRE, XFS and ZFS.
+# This package contains a library for a FSAL_XFS and an example xfs.conf file
+
 Package: nfs-ganesha-rados-grace
-Multi-Arch: same
-Architecture: any
-Section: libs
-Depends: ${misc:Depends}, ${shlibs:Depends},
-         nfs-ganesha (=${binary:Version}),
-         librados2
+Multi-Arch: foreign
+Architecture: any
+Depends: ${misc:Depends}, ${shlibs:Depends},
+         nfs-ganesha (=${binary:Version})
 Description: nfs-ganesha ganesha-rados-grace program
  NFS-GANESHA is a NFS Server running in user space with a large cache.
  It comes with various backend modules to support different file systems
@@ -144,7 +167,7 @@
  It comes with various backend modules to support different file systems
  and namespaces. Supported name spaces are POSIX, PROXY, SNMP, FUSE-like,
  HPSS, LUSTRE, XFS and ZFS.
- This package contains a library for a FSAL_MEM
+ This package contains a library for a FSAL_MEM and an example mem.conf file
 
 Package: nfs-ganesha-proxy
 Multi-Arch: same

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#
# Expected debian/rules file that is used by the dpkg build procedure
#
#   $ git clone <nfs-ganesha>
#   $ cd nfs-ganesha/src
#   $ dpkg-buildpackage -uc -us
#
export PREFIX=/usr
export DESTDIR=$(CURDIR)/debian/tmp
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	 dh $@ --with python3

override_dh_auto_configure:
	 cd src && ln -s ../debian .
	 cd src && dh_auto_configure -- \
		-DBUILD_CONFIG=debian \
		-DLIB_INSTALL_DIR=/usr/lib/ganesha \
		-DFSAL_DESTINATION=/usr/lib/${DEB_HOST_MULTIARCH}/ganesha \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DUSE_FSAL_NULL=YES \
		-DUSE_FSAL_MEM=YES \
		-DUSE_FSAL_XFS=NO \
		-DUSE_FSAL_LUSTRE=NO \
		-DUSE_FSAL_CEPH=YES \
		-DUSE_FSAL_RGW=YES \
		-DUSE_FSAL_GPFS=YES \
		-DUSE_FSAL_PANFS=NO \
		-DUSE_FSAL_GLUSTER=YES \
		-DUSE_SYSTEM_NTIRPC=YES \
		-DUSE_9P_RDMA=NO \
		-DUSE_LTTNG=NO \
		-DUSE_ADMIN_TOOLS=YES \
		-DUSE_RADOS_RECOV=YES \
		-DRADOS_URLS=YES \
		-DUSE_GUI_ADMIN_TOOLS=YES \
		-DUSE_FSAL_VFS=ON \
		-DUSE_FSAL_PROXY=ON \
		-DUSE_DBUS=ON \
		-DUSE_9P=ON \
		-DDISTNAME_HAS_GIT_DATA=OFF \
		-DUSE_MAN_PAGE=YES \
		-D_MSPAC_SUPPORT=YES \
		-DSANITIZE_ADDRESS=NO


override_dh_auto_build:
	cd src && dh_auto_build

override_dh_auto_test:

override_dh_install:
	mkdir -p debian/tmp/etc/ganesha/
	mkdir -p debian/tmp/lib/systemd/system/
	mkdir -p debian/tmp/etc/systemd/system/nfs-ganesha-lock.service.d
	mkdir -p debian/tmp/etc/default
	mkdir -p debian/tmp/etc/logrotate.d/
	mkdir -p debian/tmp/etc/dbus-1/system.d/
	mkdir -p debian/tmp/usr/lib/ganesha
	mkdir -p debian/tmp/usr/lib/${DEB_HOST_MULTIARCH}/ganesha
	mkdir -p debian/tmp/usr/sbin/
	cp src/config_samples/ganesha.conf.example debian/tmp/etc/ganesha/
	cp src/config_samples/vfs.conf debian/tmp/etc/ganesha/
	cp src/config_samples/rgw.conf debian/tmp/etc/ganesha/
	cp src/config_samples/mem.conf debian/tmp/etc/ganesha/
	cp src/config_samples/gluster.conf debian/tmp/etc/ganesha/
	cp src/config_samples/ceph.conf debian/tmp/etc/ganesha/
	cp src/config_samples/gpfs.conf debian/tmp/etc/ganesha/
	cp src/config_samples/gpfs.ganesha.exports.conf debian/tmp/etc/ganesha/
	cp src/config_samples/gpfs.ganesha.log.conf debian/tmp/etc/ganesha/
	cp src/config_samples/gpfs.ganesha.main.conf debian/tmp/etc/ganesha/
	cp src/config_samples/gpfs.ganesha.nfsd.conf debian/tmp/etc/ganesha/
	cp src/config_samples/logrotate_ganesha debian/tmp/etc/logrotate.d/nfs-ganesha
	cp src/config_samples/logrotate_fsal_gluster debian/tmp/etc/logrotate.d/nfs-ganesha-gfapi
	cp src/scripts/systemd/nfs-ganesha.service.debian8 debian/tmp/lib/systemd/system/nfs-ganesha.service
	cp src/scripts/systemd/nfs-ganesha-config.service debian/tmp/lib/systemd/system/
	cp src/scripts/systemd/nfs-ganesha-lock.service.debian10 debian/tmp/lib/systemd/system/nfs-ganesha-lock.service
	cp src/scripts/systemd/rpc-statd.conf.debian10 debian/tmp/etc/systemd/system/nfs-ganesha-lock.service.d/rpc-statd.conf
	cp src/scripts/systemd/sysconfig/nfs-ganesha debian/tmp/etc/default/
	cp src/scripts/ganeshactl/org.ganesha.nfsd.conf debian/tmp/etc/dbus-1/system.d/nfs-ganesha-dbus.conf
	install -m 0755 src/scripts/nfs-ganesha-config.sh debian/tmp/usr/lib/ganesha/
	install -m 0755 src/tools/mount.9P debian/tmp/usr/sbin/
	make -C src/obj-*-linux-gnu* install && dh_install --sourcedir=./src

override_dh_shlibdeps:
	dh_shlibdeps -l/usr/lib/${DEB_HOST_MULTIARCH}/ganesha
